	library ieee;
	use ieee.std_logic_1164.all;
	use ieee.std_logic_unsigned.all;
	use ieee.numeric_std.all;
	use ieee.math_real.all;

entity \jk_flip_flop\ is
	port(
		\set\ : in std_logic;
		\J\ : in std_logic;
		\K\ : in std_logic;
		\clock\ : in std_logic;
		\reset\ : in std_logic;
		\not_Q\ : out std_logic;
		\Q\ : out std_logic
	);
end \jk_flip_flop\;
architecture behave of \jk_flip_flop\ is
   signal temp: std_logic;
begin
	process (\clock\) 
	begin
		if rising_edge(\clock\) then                 
			if \reset\='1' then   
				temp <= '0';
			elsif \set\='1' then
				temp <= '1';
			else
				if (\J\='0' and \K\='0') then
					temp <= temp;
				elsif (\J\='0' and \K\='1') then
					temp <= '0';
				elsif (\J\='1' and \K\='0') then
					temp <= '1';
				elsif (\J\='1' and \K\='1') then
					temp <= not (temp);
				end if;
			end if;
		end if;
	end process;
	\Q\ <= temp;
	\not_Q\ <= not temp;
end behave;
